/*
 * This file is part of PySide: Python for Qt
 *
 * Copyright (C) 2009-2011 Nokia Corporation and/or its subsidiary(-ies).
 *
 * Contact: PySide team <contact@pyside.org>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * version 2.1 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA
 *
 */


//workaround to access protected functions
#define protected public

// default includes
#include <shiboken.h>
#include <pysidesignal.h>
#include <pysideproperty.h>
#include <pyside.h>
#include <destroylistener.h>
#include <typeresolver.h>
#include <typeinfo>
#include "pyside_qtcore_python.h"

#include "qmetaclassinfo_wrapper.h"

// Extra includes



// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QMetaClassInfo_Init(PyObject* self, PyObject* args, PyObject* kwds)
{
    SbkObject* sbkSelf = reinterpret_cast<SbkObject*>(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QMetaClassInfo >()))
        return -1;

    ::QMetaClassInfo* cptr = 0;
    int overloadId = -1;
    PythonToCppFunc pythonToCpp[] = { 0 };
    SBK_UNUSED(pythonToCpp)
    int numArgs = PyTuple_GET_SIZE(args);
    PyObject* pyArgs[] = {0};

    // invalid argument lengths


    if (!PyArg_UnpackTuple(args, "QMetaClassInfo", 0, 1, &(pyArgs[0])))
        return -1;


    // Overloaded function decisor
    // 0: QMetaClassInfo()
    // 1: QMetaClassInfo(QMetaClassInfo)
    if (numArgs == 0) {
        overloadId = 0; // QMetaClassInfo()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::isPythonToCppReferenceConvertible((SbkObjectType*)SbkPySide_QtCoreTypes[SBK_QMETACLASSINFO_IDX], (pyArgs[0])))) {
        overloadId = 1; // QMetaClassInfo(QMetaClassInfo)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_QMetaClassInfo_Init_TypeError;

    // Call function/method
    switch (overloadId) {
        case 0: // QMetaClassInfo()
        {

            if (!PyErr_Occurred()) {
                // QMetaClassInfo()
                PyThreadState* _save = PyEval_SaveThread(); // Py_BEGIN_ALLOW_THREADS
                cptr = new ::QMetaClassInfo();
                PyEval_RestoreThread(_save); // Py_END_ALLOW_THREADS
            }
            break;
        }
        case 1: // QMetaClassInfo(const QMetaClassInfo & QMetaClassInfo)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QMetaClassInfo cppArg0_local = ::QMetaClassInfo();
            ::QMetaClassInfo* cppArg0 = &cppArg0_local;
            if (Shiboken::Conversions::isImplicitConversion((SbkObjectType*)SbkPySide_QtCoreTypes[SBK_QMETACLASSINFO_IDX], pythonToCpp[0]))
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (!PyErr_Occurred()) {
                // QMetaClassInfo(QMetaClassInfo)
                PyThreadState* _save = PyEval_SaveThread(); // Py_BEGIN_ALLOW_THREADS
                cptr = new ::QMetaClassInfo(*cppArg0);
                PyEval_RestoreThread(_save); // Py_END_ALLOW_THREADS
            }
            break;
        }
    }

    if (PyErr_Occurred() || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QMetaClassInfo >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (!cptr) goto Sbk_QMetaClassInfo_Init_TypeError;

    Shiboken::Object::setValidCpp(sbkSelf, true);
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;

    Sbk_QMetaClassInfo_Init_TypeError:
        const char* overloads[] = {"", "PySide.QtCore.QMetaClassInfo", 0};
        Shiboken::setErrorAboutWrongArguments(args, "PySide.QtCore.QMetaClassInfo", overloads);
        return -1;
}

static PyObject* Sbk_QMetaClassInfoFunc_name(PyObject* self)
{
    ::QMetaClassInfo* cppSelf = 0;
    SBK_UNUSED(cppSelf)
    if (!Shiboken::Object::isValid(self))
        return 0;
    cppSelf = ((::QMetaClassInfo*)Shiboken::Conversions::cppPointer(SbkPySide_QtCoreTypes[SBK_QMETACLASSINFO_IDX], (SbkObject*)self));
    PyObject* pyResult = 0;

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // name()const
            PyThreadState* _save = PyEval_SaveThread(); // Py_BEGIN_ALLOW_THREADS
            const char * cppResult = const_cast<const ::QMetaClassInfo*>(cppSelf)->name();
            PyEval_RestoreThread(_save); // Py_END_ALLOW_THREADS
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<const char*>(), cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return 0;
    }
    return pyResult;
}

static PyObject* Sbk_QMetaClassInfoFunc_value(PyObject* self)
{
    ::QMetaClassInfo* cppSelf = 0;
    SBK_UNUSED(cppSelf)
    if (!Shiboken::Object::isValid(self))
        return 0;
    cppSelf = ((::QMetaClassInfo*)Shiboken::Conversions::cppPointer(SbkPySide_QtCoreTypes[SBK_QMETACLASSINFO_IDX], (SbkObject*)self));
    PyObject* pyResult = 0;

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // value()const
            PyThreadState* _save = PyEval_SaveThread(); // Py_BEGIN_ALLOW_THREADS
            const char * cppResult = const_cast<const ::QMetaClassInfo*>(cppSelf)->value();
            PyEval_RestoreThread(_save); // Py_END_ALLOW_THREADS
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<const char*>(), cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return 0;
    }
    return pyResult;
}

static PyObject* Sbk_QMetaClassInfo___copy__(PyObject* self)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    ::QMetaClassInfo& cppSelf = *(((::QMetaClassInfo*)Shiboken::Conversions::cppPointer(SbkPySide_QtCoreTypes[SBK_QMETACLASSINFO_IDX], (SbkObject*)self)));
    PyObject* pyResult = Shiboken::Conversions::copyToPython((SbkObjectType*)SbkPySide_QtCoreTypes[SBK_QMETACLASSINFO_IDX], &cppSelf);
    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return 0;
    }
    return pyResult;
}

static PyMethodDef Sbk_QMetaClassInfo_methods[] = {
    {"name", (PyCFunction)Sbk_QMetaClassInfoFunc_name, METH_NOARGS},
    {"value", (PyCFunction)Sbk_QMetaClassInfoFunc_value, METH_NOARGS},

    {"__copy__", (PyCFunction)Sbk_QMetaClassInfo___copy__, METH_NOARGS},
    {0} // Sentinel
};

} // extern "C"

static int Sbk_QMetaClassInfo_traverse(PyObject* self, visitproc visit, void* arg)
{
    return reinterpret_cast<PyTypeObject*>(&SbkObject_Type)->tp_traverse(self, visit, arg);
}
static int Sbk_QMetaClassInfo_clear(PyObject* self)
{
    return reinterpret_cast<PyTypeObject*>(&SbkObject_Type)->tp_clear(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static SbkObjectType Sbk_QMetaClassInfo_Type = { { {
    PyVarObject_HEAD_INIT(&SbkObjectType_Type, 0)
    /*tp_name*/             "PySide.QtCore.QMetaClassInfo",
    /*tp_basicsize*/        sizeof(SbkObject),
    /*tp_itemsize*/         0,
    /*tp_dealloc*/          &SbkDeallocWrapper,
    /*tp_print*/            0,
    /*tp_getattr*/          0,
    /*tp_setattr*/          0,
    /*tp_compare*/          0,
    /*tp_repr*/             0,
    /*tp_as_number*/        0,
    /*tp_as_sequence*/      0,
    /*tp_as_mapping*/       0,
    /*tp_hash*/             0,
    /*tp_call*/             0,
    /*tp_str*/              0,
    /*tp_getattro*/         0,
    /*tp_setattro*/         0,
    /*tp_as_buffer*/        0,
    /*tp_flags*/            Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_CHECKTYPES|Py_TPFLAGS_HAVE_GC,
    /*tp_doc*/              0,
    /*tp_traverse*/         Sbk_QMetaClassInfo_traverse,
    /*tp_clear*/            Sbk_QMetaClassInfo_clear,
    /*tp_richcompare*/      0,
    /*tp_weaklistoffset*/   0,
    /*tp_iter*/             0,
    /*tp_iternext*/         0,
    /*tp_methods*/          Sbk_QMetaClassInfo_methods,
    /*tp_members*/          0,
    /*tp_getset*/           0,
    /*tp_base*/             reinterpret_cast<PyTypeObject*>(&SbkObject_Type),
    /*tp_dict*/             0,
    /*tp_descr_get*/        0,
    /*tp_descr_set*/        0,
    /*tp_dictoffset*/       0,
    /*tp_init*/             Sbk_QMetaClassInfo_Init,
    /*tp_alloc*/            0,
    /*tp_new*/              SbkObjectTpNew,
    /*tp_free*/             0,
    /*tp_is_gc*/            0,
    /*tp_bases*/            0,
    /*tp_mro*/              0,
    /*tp_cache*/            0,
    /*tp_subclasses*/       0,
    /*tp_weaklist*/         0
}, },
    /*priv_data*/           0
};
} //extern


// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QMetaClassInfo_PythonToCpp_QMetaClassInfo_PTR(PyObject* pyIn, void* cppOut) {
    Shiboken::Conversions::pythonToCppPointer(&Sbk_QMetaClassInfo_Type, pyIn, cppOut);
}
static PythonToCppFunc is_QMetaClassInfo_PythonToCpp_QMetaClassInfo_PTR_Convertible(PyObject* pyIn) {
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, (PyTypeObject*)&Sbk_QMetaClassInfo_Type))
        return QMetaClassInfo_PythonToCpp_QMetaClassInfo_PTR;
    return 0;
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject* QMetaClassInfo_PTR_CppToPython_QMetaClassInfo(const void* cppIn) {
    PyObject* pyOut = (PyObject*)Shiboken::BindingManager::instance().retrieveWrapper(cppIn);
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    const char* typeName = typeid(*((::QMetaClassInfo*)cppIn)).name();
    return Shiboken::Object::newObject(&Sbk_QMetaClassInfo_Type, const_cast<void*>(cppIn), false, false, typeName);
}

// C++ to Python copy conversion.
static PyObject* QMetaClassInfo_COPY_CppToPython_QMetaClassInfo(const void* cppIn) {
    return Shiboken::Object::newObject(&Sbk_QMetaClassInfo_Type, new ::QMetaClassInfo(*((::QMetaClassInfo*)cppIn)), true, true);
}

// Python to C++ copy conversion.
static void QMetaClassInfo_PythonToCpp_QMetaClassInfo_COPY(PyObject* pyIn, void* cppOut) {
    *((::QMetaClassInfo*)cppOut) = *((::QMetaClassInfo*)Shiboken::Conversions::cppPointer(SbkPySide_QtCoreTypes[SBK_QMETACLASSINFO_IDX], (SbkObject*)pyIn));
}
static PythonToCppFunc is_QMetaClassInfo_PythonToCpp_QMetaClassInfo_COPY_Convertible(PyObject* pyIn) {
    if (PyObject_TypeCheck(pyIn, (PyTypeObject*)&Sbk_QMetaClassInfo_Type))
        return QMetaClassInfo_PythonToCpp_QMetaClassInfo_COPY;
    return 0;
}

void init_QMetaClassInfo(PyObject* module)
{
    SbkPySide_QtCoreTypes[SBK_QMETACLASSINFO_IDX] = reinterpret_cast<PyTypeObject*>(&Sbk_QMetaClassInfo_Type);

    if (!Shiboken::ObjectType::introduceWrapperType(module, "QMetaClassInfo", "QMetaClassInfo",
        &Sbk_QMetaClassInfo_Type, &Shiboken::callCppDestructor< ::QMetaClassInfo >)) {
        return;
    }

    // Register Converter
    SbkConverter* converter = Shiboken::Conversions::createConverter(&Sbk_QMetaClassInfo_Type,
        QMetaClassInfo_PythonToCpp_QMetaClassInfo_PTR,
        is_QMetaClassInfo_PythonToCpp_QMetaClassInfo_PTR_Convertible,
        QMetaClassInfo_PTR_CppToPython_QMetaClassInfo,
        QMetaClassInfo_COPY_CppToPython_QMetaClassInfo);

    Shiboken::Conversions::registerConverterName(converter, "QMetaClassInfo");
    Shiboken::Conversions::registerConverterName(converter, "QMetaClassInfo*");
    Shiboken::Conversions::registerConverterName(converter, "QMetaClassInfo&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QMetaClassInfo).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QMetaClassInfo_PythonToCpp_QMetaClassInfo_COPY,
        is_QMetaClassInfo_PythonToCpp_QMetaClassInfo_COPY_Convertible);


    qRegisterMetaType< ::QMetaClassInfo >("QMetaClassInfo");
}
